/********************************************************************************
 *   dbgreader -- system debug output reader for Windows CE                     *
 *                                                                              * 
 *   Copyright (C) 2004-2007 dci (dev@cpp.in)                                   *
 *                                                                              *
 *   This program is free software; you can redistribute it and/or              *
 *   modify it under the terms of the GNU General Public License version 2      *
 *   as published by the Free Software Foundation.                              *
 *                                                                              *
 *   This program is distributed in the hope that it will be useful,            *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of             *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU          *
 *   General Public License version 2 for more details.                         *
 *                                                                              *
 *   You should have received a copy of the GNU General Public License          *
 *   version 2 along with this library; if not, write to the Free Software      *
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA  *
 ********************************************************************************
 */


/*
Parts of my tiny C & ARM runtimes.
*/

#include "rt.h"

char mylchar ( char ichar )
{
	return ( ( ichar >= 0x41 ) && ( ichar <= 0x5a ) ) ? ichar + 0x20 : ichar;
}

int mymemicmp ( void * mem1, void * mem2, unsigned long num )
{
	int ret = 0;
	unsigned long i;
	for ( i = 0; ( i < num ) && ( ret == 0 ); i++ )
	{
		ret = mylchar ( ( ( char * ) mem1 ) [i] ) - mylchar ( ( ( char * ) mem2 ) [i] );
	}
	return ret;
}

size_t mymemcpy ( void * out, void * in, size_t num )
{
	size_t cnt;
	for ( cnt = 0; cnt < num; ++cnt ) ( ( unsigned char * ) out ) [ cnt ] = ( ( unsigned char * ) in ) [ cnt ];
	return num;
}

size_t mywcsncpy ( wchar_t * out, wchar_t * in, size_t outnum )
{
	size_t offset = 0;
	for ( offset = 0; offset < outnum; ++offset )
	{
		if ( 0 == ( out [ offset ] = in [ offset ] ) ) break;
	}
	out [ outnum - 1 ] = 0;
	return offset;
}

size_t mywcscpy ( wchar_t * out, wchar_t * in )
{
	size_t ret = 0;
	while ( 1 )
	{
		* out = * in;
		if ( 0 == * out ) break;
		++in; ++out; ++ret;
	}
	return ret;
}

size_t mywcslen ( wchar_t * str )
{
	wchar_t * reader = str;
	while ( * reader ) ++reader;
	return ( reader - str );
}

/* 'function must return a value' */
#pragma warning ( disable: 4716 )

__declspec(naked) unsigned long cpsr_get ( )
{
	__emit ( 0xE10F0000 ); /* MRS	R0, CPSR */
	__emit ( 0xE12FFF1E ); /* BX	LR */
}

#pragma warning ( default: 4716 )